/// <reference types="react" />
import * as THREE from 'three'
import { CanvasContext, RenderCallback } from './canvas'
declare type Omit<T, K extends keyof T> = Pick<T, Exclude<keyof T, K>>
export declare function useRender(fn: RenderCallback, takeOverRenderloop?: boolean, deps?: any[]): void
export declare function useFrame(fn: RenderCallback, deps?: any[]): void
export declare function useGl(fn: RenderCallback, deps?: any[]): void
export declare function useThree(): Omit<CanvasContext, 'subscribe'>
export declare function useUpdate<T>(
  callback: (props: T) => void,
  dependents: any[],
  optionalRef?: React.MutableRefObject<T>
): React.MutableRefObject<any>
export declare function useResource<T>(optionalRef?: React.MutableRefObject<T>): [React.MutableRefObject<T>, T]
declare type Content = {
  geometry: THREE.Geometry | THREE.BufferGeometry
  material: THREE.Material | THREE.Material[]
}
declare type Extensions = (loader: THREE.Loader) => void
export declare function useLoader(proto: THREE.Loader, url: string, extensions?: Extensions): Content[]
export {}
